﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace S01TCSingle
{
    public partial class Form1 : Form
    {
        const short devId = 0;//装置のID
        byte TCType;//熱電対の種類

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            TypeSelect.SelectedIndex = 0;
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (StartStopBtn.Text == "停止")
            {
                MeasStop();
            }
        }

        private void MeasStart()
        {
            short Ret;
            try
            {
                Ret = TUSBSTC.Tusbs01tc_Device_Open(devId);
                if (Ret != 0)
                {
                    MessageBox.Show(TUSBSTC.GetErrMessage(Ret));
                    return;
                }
                else
                {
                    TypeSelect.Enabled = false;
                    TCType = (byte)TypeSelect.SelectedIndex;

                    Timer1.Enabled = true;
                    StartStopBtn.Text = "停止";
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                this.Close();
            }
        }

        private void MeasStop()
        {
            Timer1.Enabled = false;
            TUSBSTC.Tusbs01tc_Device_Close(devId);
            StartStopBtn.Text = "開始";
            TypeSelect.Enabled = true;
        }

        private void StartStopBtn_Click(object sender, EventArgs e)
        {
            switch (StartStopBtn.Text)
            {
                case "開始":
                    MeasStart();
                    break;
                case "停止":
                    MeasStop();
                    break;
            }
        }

        private void Timer1_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            short Ret;
            int Cnt;
            double tmpData;
            double vData;//電圧データ
            double tData;//温度データ

            Timer1.Enabled = false;//タイマーは一旦停止
            vData = 0.0;
            tData = 0.0;
            for (Cnt = 0; Cnt < 100; Cnt++)
            {
                Ret = TUSBSTC.Tusbs01tc_Single_Sample(devId,out tmpData, 8);//電圧データの取得
                if(Ret != 0)
                {
                    MessageBox.Show(TUSBSTC.GetErrMessage(Ret));
                    MeasStop();
                    return;
                }
                vData += tmpData;
                Ret = TUSBSTC.Tusbs01tc_Single_Sample(devId, out tmpData, TCType);//温度データの取得
                if (Ret != 0)
                {
                    MessageBox.Show(TUSBSTC.GetErrMessage(Ret));
                    MeasStop();
                    return;
                }
                tData += tmpData;
            }
            vData /= 100.0;
            tData /= 100.0;

            VoltDisp.Text = vData.ToString("000000");
            TempDisp.Text = tData.ToString("0000.0");

            Timer1.Enabled = true;//タイマー再開
        }
    }
}
