﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace S01TCTimer
{
    public partial class Form1 : Form
    {
        byte TCType;//熱電対の種類
        byte TotalCnt;//総取込数
        const short devID = 0;//装置のID

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            TypeSelect.SelectedIndex = 0;
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (StartBtn.Text == "中止")
                MeasAbort();
        }

        private void MeasStart()
        {
            short Ret;
            try
            {
                Ret = TUSBSTC.Tusbs01tc_Device_Open(devID);
                if (Ret != 0)
                {
                    MessageBox.Show(TUSBSTC.GetErrMessage(Ret));
                    return;
                }
                else
                {
                    TypeSelect.Enabled = false;
                    TCType = (byte)TypeSelect.SelectedIndex;

                    ResultView.Text = "";
                    TotalCnt = 0;
                    Ret = TUSBSTC.Tusbs01tc_Start_Sample(devID, 1);//取込開始
                    Timer1.Enabled = true;
                    StartBtn.Text = "中止";
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return;
            }
        }

        private void MeasAbort()
        {
            Timer1.Enabled = false;
            TUSBSTC.Tusbs01tc_Device_Close(devID);
            StartBtn.Text = "取込";
            TypeSelect.Enabled = true;
        }

        private void StartBtn_Click(object sender, EventArgs e)
        {
            switch (StartBtn.Text)
            {
                case "取込":
                    MeasStart();
                    break;
                case "中止":
                    MeasAbort();
                    break;
            }
        }

        private void Timer1_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            short Ret;
            byte DataSize = 10;
            double[] tData = new double[DataSize];
            byte[] SerNum = new byte[DataSize];
            int Cnt;

            Timer1.Enabled = false;//一旦タイマー停止
            Ret = TUSBSTC.Tusbs01tc_Get_Datas(devID, tData, SerNum, ref DataSize, TCType);

            for (Cnt = 0; Cnt < DataSize; Cnt++)
            {
                ResultView.Text = ResultView.Text + tData[Cnt].ToString("000.0 ℃") + "\r\n";
                TotalCnt += 1;
                if (TotalCnt > 9)
                {
                    MeasAbort();//終了
                    return;
                }
            }
            Timer1.Enabled = true;//タイマー再開
        }
    }
}
