﻿using System.Runtime.InteropServices;

class TUSBSTC
{
    [DllImport("TUSBSTC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01tc_Device_Open(short Id);
    [DllImport("TUSBSTC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern void Tusbs01tc_Device_Close(short Id);
    [DllImport("TUSBSTC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01tc_Single_Sample(short Id,out double Data, byte sType);
    [DllImport("TUSBSTC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01tc_Start_Sample(short Id,short SampleRate);
    [DllImport("TUSBSTC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01tc_Get_Datas(short Id,[Out] double[] Data,[Out] byte[] SerNum,ref byte size, byte sType);

    [DllImport("TUSBSTC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01tc_Single_Sample_Ex(short Id, out double VData, out double TData);
    [DllImport("TUSBSTC.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01tc_Get_Datas_Ex(short Id, [Out] double[] VData, [Out] double[] TData, [Out] byte[] SerNum, ref byte size);

    public static string GetErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "ID番号が不正です";
            case 2:
                return "ドライバがインストールされていません";
            case 3:
                return "すでにデバイスはオープンされています";
            case 4:
                return "接続されている台数が多すぎます";
            case 5:
                return "オープンできませんでした";
            case 6:
                return "デバイスがみつかりません";
            case 7:
                return "オープンされていません";
            case 8:
                return "パラメータエラー";
            case 9:
                return "USB通信エラーです";
            default:
                return "不明なエラーです";
        }
    }

}

