﻿Public Class Form1
    Dim TCType As Byte '熱電対の種類
    Const devID As Short = 0 '装置のID

    Private Sub Form1_FormClosed(sender As Object, e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        If StartStopBtn.Text = "停止" Then
            MeasStop()
        End If
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        TypeSelect.SelectedIndex = 0
    End Sub

    Private Sub MeasStart()
        Dim Ret As Short
        Ret = Tusbs01tc_Device_Open(devID)
        If (Ret <> 0) Then
            Tusbs01tc_GetErrMessage(Ret)
            Exit Sub
        End If

        TypeSelect.Enabled = False
        TCType = TypeSelect.SelectedIndex

        Timer1.Enabled = True
        StartStopBtn.Text = "停止"
    End Sub

    Private Sub MeasStop()
        Timer1.Enabled = False
        Tusbs01tc_Device_Close((devID))
        StartStopBtn.Text = "開始"
        TypeSelect.Enabled = True
    End Sub

    Private Sub StartStopBtn_Click(sender As System.Object, e As System.EventArgs) Handles StartStopBtn.Click
        Select Case StartStopBtn.Text
            Case "開始"
                MeasStart()
            Case "停止"
                MeasStop()
        End Select
    End Sub

    Private Sub Timer1_Elapsed(sender As System.Object, e As System.Timers.ElapsedEventArgs) Handles Timer1.Elapsed
        Dim Ret As Short
        Dim Cnt As Integer
        Dim tmpData As Double
        Dim vData As Double '電圧データ
        Dim tData As Double '温度データ

        Timer1.Enabled = False 'タイマーは一旦停止
        vData = 0.0
        tData = 0.0
        For cnt = 0 To 99
            Ret = Tusbs01tc_Single_Sample(devID, tmpData, 8) '電圧データの取得
            If Ret <> 0 Then
                Tusbs01tc_GetErrMessage(Ret)
                MeasStop()
                Exit Sub
            End If
            vData += tmpData
            Ret = Tusbs01tc_Single_Sample(devID, tmpData, TCType) '温度データの取得
            If Ret <> 0 Then
                Tusbs01tc_GetErrMessage(Ret)
                MeasStop()
                Exit Sub
            End If
            tData += tmpData
        Next
        vData /= 100.0
        tData /= 100.0

        VoltDisp.Text = vData.ToString("000000")
        TempDisp.Text = tData.ToString("0000.0")

        Timer1.Enabled = True 'タイマー再開
    End Sub
End Class
